//*----------------------------------------------------------------------------
// TOOLS.H
//*----------------------------------------------------------------------------
#ifndef __TOOLS_H
#define __TOOLS_H
//*----------------------------------------------------------------------------
// HIER STEHEN ALLE INCLUDES
// in allen Dateien muss deshalb nur die "tools.h" eingebunden werden
//*----------------------------------------------------------------------------

#include <stdio.h>
#include <stdlib.h>

#define F_CPU 7372800

#include <util/delay.h>


#include <inttypes.h>  
#include <string.h>
#include <math.h>
#include <avr/io.h>		// include I/O definitions (port names, pin names, etc)
#include <stdbool.h>
#include <avr/pgmspace.h>
#include <avr/interrupt.h>
#include <avr/eeprom.h>
#include "typedefs.h"
#include "system.h"
#include "spi.h"
#include "lcd_dogm128.h"
#include "xitoa.h"
void delay_ms(uint8_t msec);// 100 msec
void delay_s(uint8_t sec); // 1 sec




// KONSTANTEN
//*----------------------------------------------------------------------------
#define VERSION_HI    1
#define VERSION_LO    0
#define VERSION_SUB   2
//*----------------------------------------------------------------------------

//*----------------------------------------------------------------------------
// FUNKTIONS-PROTOTYPEN TOOLS.C
//*----------------------------------------------------------------------------

//#define  RPRINTF_FLOAT 
#define nop()   do { __asm__ __volatile__ ("nop"); } while (0)



#define BIT_TOGGLE(Port,Bit)          {if(Port&(1<<Bit)) {Port &= ~(1<<Bit);} else {Port |=(1<<Bit);}}
#define LED_TOGGLE(Port,Bit)          {if(Port&(1<<Bit)) {Port &= ~(1<<Bit);} else {Port |=(1<<Bit);}}


#define BIT_SET_HI(Port,Bit)             {Port |=(1<<Bit);}
#define BIT_SET_LO(Port,Bit)             {Port &= ~(1<<Bit);}

#define RELAIS_EIN       	PORTC
#define DDR_RELAIS       	DDRC
#define BIT_RELAIS       	0

#define LED_EIN_1           PORTC
#define DDR_LED_1           DDRC
#define BIT_LED_1           1

#define LED_EIN_2           PORTC
#define DDR_LED_2           DDRC
#define BIT_LED_2           2

#define LED_EIN_3           PORTC
#define DDR_LED_3           DDRC
#define BIT_LED_3           3


#define RELAIS_ON()          BIT_SET_HI(RELAIS_EIN,BIT_RELAIS)
#define RELAIS_OFF()         BIT_SET_LO(RELAIS_EIN,BIT_RELAIS)
#define RELAIS_TOGGLE()      BIT_TOGGLE(RELAIS_EIN,BIT_RELAIS)

#define LED_ON_1()             BIT_SET_HI(LED_EIN_1,BIT_LED_1)
#define LED_OFF_1()            BIT_SET_LO(LED_EIN_1,BIT_LED_1)
#define LED_TOGGLE_1()         BIT_TOGGLE(LED_EIN_1,BIT_LED_1)

#define LED_ON_2()             BIT_SET_HI(LED_EIN_2,BIT_LED_2)
#define LED_OFF_2()            BIT_SET_LO(LED_EIN_2,BIT_LED_2)
#define LED_TOGGLE_2()         BIT_TOGGLE(LED_EIN_2,BIT_LED_2)

#define LED_ON_3()             BIT_SET_HI(LED_EIN_3,BIT_LED_3)
#define LED_OFF_3()            BIT_SET_LO(LED_EIN_3,BIT_LED_3)
#define LED_TOGGLE_3()         BIT_TOGGLE(LED_EIN_3,BIT_LED_3)



//*----------------------------------------------------------------------------
// EEMEM 
//*----------------------------------------------------------------------------

#ifndef EEMEM
#define EEMEM  __attribute__ ((section (".eeprom")))
#endif


//*----------------------------------------------------------------------------
#endif
